;
; dq6_optimized_string_util.asm
;

;--------------------------------
; getStringPointer(X: ptr, A: strId)
;--------------------------------
org $C0315E
getStringPointer:
    PHP
    REP #$30
    PHA
    PHX
    PHY
    PHB
    SEI
    CMP #$09A7
    BCC .begin

    CMP #$09CA
    BCC $31C7

.begin
    TAY
    AND #$000F
    PHA
    PHX
    TYA
    LSR
    LSR
    LSR
    LSR
    STA $00,X
    ASL
    ADC $00,X
    TAX
    LDA $C165E7,X
    ADC #$8703
    TAY
    SEP #$20
    LDA $C165E9,X
    ADC #$FB
    PLX
    STY $00,X
    STA $02,X
    PHA
    PLB
    REP #$20
    PLY
    BEQ .ret

.increment_pointer
    LDA ($00,X)
    INC $00,X
    BEQ .bank_boundary

.back
    AND #$00FF
    CMP #$00AC
    BNE .increment_pointer

    DEY
    BNE .increment_pointer

.ret
    PLB
    PLY
    PLX
    PLA
    PLP
    RTL

.bank_boundary
    INC $02,X
    BRA .back

    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP : NOP
    NOP : NOP : NOP

;--------------------------------
; getCharacterFromPointer(X: ptr)
;--------------------------------
org $C031FA
getCharacterFromPointer:
    PHP
    REP #$10
    PHX
    PHB
    SEI
    SEP #$20
    LDA $02,X
    PHA
    PLB
    LDA ($00,X)
    REP #$20
    AND #$00FF
    INC $00,X
    BEQ .bank_boundary

.back
    CMP #$00C9
    BCS .getDakuonHandakuon

    PLB
    PLX
    PLP
    RTL

.bank_boundary
    INC $02,X
    BRA .back

    NOP : NOP : NOP : NOP
    NOP : NOP : NOP

.getDakuonHandakuon
    TAX
    CMP #$00FC
    BCS .punctuation_mark

    CMP #$00F2
    BCS .handakuon

    LDA #$8400
    SEP #$20
    LDA $C0297B-$00C9,X
    PLB
    PLX
    PLP
    RTL

.handakuon
    LDA #$8300
    SEP #$20
    LDA $C029A4-$00F2,X
    PLB
    PLX
    PLP
    RTL

.punctuation_mark
    LDA $C029AE-$00FC,X
    AND #$00FF
    PLB
    PLX
    PLP
    RTL
